package;

import hage.HGE;
import hage.HGEData.TextAlign;
import hage.HGEGame;
import hage.HGEText;

import kha.Configuration;
import kha.Font;
import kha.FontStyle;
import kha.Loader;
import kha.LoadingScreen;


class Pong extends HGEGame {
	/**Ball reference*/
	private var ball:Ball;
	/**Player paddle reference*/
	private var player:PlayerPaddle;
	/**Enemy paddle reference*/
	private var enemy:EnemyPaddle;
	
	/**Player points text reference*/
	private var playerPointsText:HGEText;
	/**Enemy points text reference*/
	private var enemyPointsText:HGEText;
	
	public function new()
	{
		super("Pong");
	}

	override function init(): Void
	{
		super.init();
		
		Configuration.setScreen(new LoadingScreen());
		Loader.the.loadRoom("level", initLevel);
	}
	
	override private function initLevel(): Void {
		super.initLevel();
		
		//Init data
		new Data();
		
		//Get font from loader
		var font:Font = Loader.the.loadFont("Nokia", new FontStyle(false, false, false), 16);
		
		//Player points text
		playerPointsText = new HGEText(0, Math.floor(HGE.height / 40), Math.floor(HGE.height / 32) * 8, font);
		playerPointsText.text = "" + Data.instance.playerPoints;
		playerPointsText.setAlign(TextAlign.CENTER, HGE.width / 2);
		playerPointsText.scaleX = playerPointsText.scaleY = HGE.width / 50;
		add(playerPointsText);
		
		//Enemy points text
		enemyPointsText = new HGEText(Math.floor(HGE.width / 2), Math.floor(HGE.height / 40), Math.floor(HGE.height / 32) * 8, font);
		enemyPointsText.text = "" + Data.instance.enemyPoints;
		enemyPointsText.setAlign(TextAlign.CENTER, HGE.width / 2);
		enemyPointsText.scaleX = enemyPointsText.scaleY = HGE.width / 50;
		add(enemyPointsText);
		
		//Player paddle
		player = new PlayerPaddle(HGE.width / 40, 10);
		add(player);
		//Enemy paddle
		enemy = new EnemyPaddle(HGE.width - player.width - player.x);
		add(enemy);
		
		//Add one ball
		for(i in 0...1) {
			ball = new Ball(HGE.width / 2, HGE.height / 2);
			add(ball);
		}
		
		//Set screen
		Configuration.setScreen(this);
	}
	
	override public function update()
	{
		//Update text
		playerPointsText.text = "" + Data.instance.playerPoints;
		enemyPointsText.text = "" + Data.instance.enemyPoints;
		
		super.update();
	}
	
	override public function prerender()
	{
		
	}
}